unit Buch;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, DBGrids, StdCtrls, DB, DBTables, ExtCtrls;

type
  TBuchForm = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Table2: TTable;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    EditInv: TEdit;
    EditAutor: TEdit;
    EditTitel: TEdit;
    Button1: TButton;
    Button2: TButton;
    Table1Inv: TStringField;
    Table1Autor: TStringField;
    Table1Titel: TStringField;
    procedure EditInvChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure DBGrid1DblClick(Sender: TObject);
    procedure EditInvKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DBGrid1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  BuchForm: TBuchForm;

implementation

{$R *.DFM}
uses Main,Helper;

procedure TBuchForm.EditInvChange(Sender: TObject);
var s:string;
begin
  if pos('+',EditInv.Text)>0 then
    begin
      EditInv.Text:=Table1.FieldByName('Inv').AsString;
      EditAutor.Text:=Table1.FieldByName('Autor').AsString;
      EditTitel.Text:=Table1.FieldByName('Titel').AsString;
      EditInv.SelectAll;
    end else begin
      s:=EditInv.Text;
      if pos('+',s)>0 then delete(s,pos('+',s),1);
      Table1.SetKey;
      Table1.Fields[0].AsString :=s;
      Table1.GoToNearest;
    end;
end;


procedure TBuchForm.Button1Click(Sender: TObject);
var idd:longint;
begin
  if (EditInv.Text='') or (EditTitel.Text='') or (EditAutor.Text='') then begin
    MessageDlg('Bitte Inventarnummer, Autor und Titel eingeben!',
    mtWarning, [mbOK], 0);
    exit;
  end;
  with table2 do begin
    last;
    idd:=FieldByName('id').asinteger+1;
  end;
  with MainForm.Table2 do
    begin
      append;
      FieldByName('ID').AsInteger:=idd;
      FieldByName('PID').AsString:=
        MainForm.Table1.FieldByName('ID').asstring;
      FieldByName('Datum').AsDateTime:=date;
      FieldByName('Inv').AsString:=EditInv.Text;
      FieldByName('Titel').AsString:=EditTitel.Text;
      FieldByName('Autor').AsString:=EditAutor.Text;
      post;
      EditInv.clear;
      EditTitel.clear;
      EditAutor.clear;
      EditInv.setfocus;
    end;
end;

procedure TBuchForm.FormShow(Sender: TObject);
begin
  editinv.setfocus;
end;

procedure TBuchForm.Button2Click(Sender: TObject);
begin
  hide;
  mainform.button2.setfocus;
end;

procedure TBuchForm.DBGrid1DblClick(Sender: TObject);
begin
  editinv.text:=table1.fieldbyname('inv').asstring+'+';
end;

procedure TBuchForm.EditInvKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case key of
    vk_Down: table1.next;
    vk_up: table1.prior;
  end;
end;

procedure TBuchForm.DBGrid1KeyPress(Sender: TObject; var Key: Char);
begin
  if key='+' then begin
    EditInv.Text:=Table1.FieldByName('Inv').AsString;
    EditAutor.Text:=Table1.FieldByName('Autor').AsString;
    EditTitel.Text:=Table1.FieldByName('Titel').AsString;
    EditInv.SelectAll;
  end;
end;

end.
