unit Pers_s;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables, Grids, DBGrids, ExtCtrls;

type
  TPersSearchForm = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Table1EID: TStringField;
    Table1Vorname: TStringField;
    Table1Name: TStringField;
    Panel1: TPanel;
    Label1: TLabel;
    EditID: TEdit;
    Label2: TLabel;
    EditName: TEdit;
    OK: TButton;
    Button1: TButton;
    Table1Id: TIntegerField;
    procedure EditIDChange(Sender: TObject);
    procedure EditNameChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure EditNameKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EditIDKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  PersSearchForm: TPersSearchForm;

implementation

{$R *.DFM}

procedure TPersSearchForm.EditIDChange(Sender: TObject);
begin
  Table1.indexname:='byEID';
  Table1.SetKey;
  Table1.Fields[0].AsString :=EditID.Text;
  Table1.GoToNearest;
end;

procedure TPersSearchForm.EditNameChange(Sender: TObject);
begin
  Table1.indexname:='byName';
  Table1.SetKey;
  Table1.FieldbyName('Name').AsString :=EditName.Text;
  Table1.GoToNearest;
end;

procedure TPersSearchForm.FormShow(Sender: TObject);
begin
  EditID.clear;
  EditName.clear;
  EditName.setfocus;
end;

procedure TPersSearchForm.EditNameKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case key of
    vk_Down: table1.next;
    vk_up: table1.prior;
  end;
end;

procedure TPersSearchForm.EditIDKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case key of
    vk_Down: table1.next;
    vk_up: table1.prior;
  end;
end;

end.
